// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.internal.taglib;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.component.UISelectManyListbox;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/** 
 * JSP Tag class, generated from template {@code tag1.2.stg} with class 
 * {@link org.apache.myfaces.tobago.internal.taglib.component.SelectManyListboxTagDeclaration}.
 */
public final class SelectManyListboxTag extends TobagoELTag {
  private static final Logger LOG = LoggerFactory.getLogger(SelectManyListboxTag.class);
  private javax.el.ValueExpression  validatorMessage;
  private javax.el.ValueExpression  converter;
  private javax.el.MethodExpression  validator;
  private javax.el.ValueExpression  focus;
  private javax.el.ValueExpression  tabIndex;
  private javax.el.ValueExpression  required;
  private javax.el.ValueExpression  readonly;
  private javax.el.ValueExpression  disabled;
  private javax.el.ValueExpression  tip;
  private javax.el.ValueExpression  converterMessage;
  private javax.el.ValueExpression  value;
  private javax.el.ValueExpression  markup;
  private javax.el.MethodExpression  valueChangeListener;
  private javax.el.ValueExpression  onchange;
  private javax.el.ValueExpression  label;
  private javax.el.ValueExpression  requiredMessage;

  @Override
  public String getComponentType() {
    return UISelectManyListbox.COMPONENT_TYPE;
  }
  @Override
  public String getRendererType() {
    return "SelectManyListbox";
  }

  @Override
  protected void setProperties(final UIComponent uiComponent) {
    super.setProperties(uiComponent);
    final UISelectManyListbox component = (UISelectManyListbox) uiComponent;
    final FacesContext context = FacesContext.getCurrentInstance();
    final Application application = context.getApplication();
    if (validatorMessage != null) {
      component.setValueExpression("validatorMessage", validatorMessage);
    }

    if (converter != null) {
      if (!converter.isLiteralText()) {
        component.setValueExpression("converter", converter);
      } else {
        component.setConverter(application.createConverter(converter.getExpressionString()));
      }
    }
    if (validator != null) {
      component.addValidator(new javax.faces.validator.MethodExpressionValidator(validator));
    }
    if (focus != null) {
      if (!focus.isLiteralText()) {
        component.setValueExpression("focus", focus);
      } else {
        component.setFocus(Boolean.parseBoolean(focus.getExpressionString()));
      }
    }
    if (tabIndex != null) {
      if (!tabIndex.isLiteralText()) {
        component.setValueExpression("tabIndex", tabIndex);
      } else {
        component.setTabIndex(Integer.parseInt(tabIndex.getExpressionString()));
      }
    }
    if (required != null) {
      if (!required.isLiteralText()) {
        component.setValueExpression("required", required);
      } else {
        component.setRequired(Boolean.parseBoolean(required.getExpressionString()));
      }
    }
    if (readonly != null) {
      if (!readonly.isLiteralText()) {
        component.setValueExpression("readonly", readonly);
      } else {
        component.setReadonly(Boolean.parseBoolean(readonly.getExpressionString()));
      }
    }
    if (disabled != null) {
      if (!disabled.isLiteralText()) {
        component.setValueExpression("disabled", disabled);
      } else {
        component.setDisabled(Boolean.parseBoolean(disabled.getExpressionString()));
      }
    }
    if (tip != null) {
      component.setValueExpression("tip", tip);
    }

    if (converterMessage != null) {
      component.setValueExpression("converterMessage", converterMessage);
    }

    if (value != null) {
      component.setValueExpression("value", value);
    }

    if (markup != null) {
      if (!markup.isLiteralText()) {
        component.setValueExpression("markup", markup);
      } else {
        component.setMarkup(org.apache.myfaces.tobago.context.Markup.valueOf(markup.getExpressionString()));
      }
    }
    if (valueChangeListener != null) {
      component.addValueChangeListener(new javax.faces.event.MethodExpressionValueChangeListener(valueChangeListener));
    }
    if (onchange != null) {
      component.setValueExpression("onchange", onchange);
    }

    if (label != null) {
      component.setValueExpression("label", label);
    }

    if (requiredMessage != null) {
      component.setValueExpression("requiredMessage", requiredMessage);
    }

  }

  public javax.el.ValueExpression getValidatorMessage() {
    return validatorMessage;
  }

  public void setValidatorMessage(final javax.el.ValueExpression validatorMessage) {
    this.validatorMessage = validatorMessage;
  }

  public javax.el.ValueExpression getConverter() {
    return converter;
  }

  public void setConverter(final javax.el.ValueExpression converter) {
    this.converter = converter;
  }

  public javax.el.MethodExpression getValidator() {
    return validator;
  }

  public void setValidator(final javax.el.MethodExpression validator) {
    this.validator = validator;
  }

  public javax.el.ValueExpression getFocus() {
    return focus;
  }

  public void setFocus(final javax.el.ValueExpression focus) {
    this.focus = focus;
  }

  public javax.el.ValueExpression getTabIndex() {
    return tabIndex;
  }

  public void setTabIndex(final javax.el.ValueExpression tabIndex) {
    this.tabIndex = tabIndex;
  }

  public javax.el.ValueExpression getRequired() {
    return required;
  }

  public void setRequired(final javax.el.ValueExpression required) {
    this.required = required;
  }

  public javax.el.ValueExpression getReadonly() {
    return readonly;
  }

  public void setReadonly(final javax.el.ValueExpression readonly) {
    this.readonly = readonly;
  }

  public javax.el.ValueExpression getDisabled() {
    return disabled;
  }

  public void setDisabled(final javax.el.ValueExpression disabled) {
    this.disabled = disabled;
  }

  public javax.el.ValueExpression getTip() {
    return tip;
  }

  public void setTip(final javax.el.ValueExpression tip) {
    this.tip = tip;
  }

  public javax.el.ValueExpression getConverterMessage() {
    return converterMessage;
  }

  public void setConverterMessage(final javax.el.ValueExpression converterMessage) {
    this.converterMessage = converterMessage;
  }

  public javax.el.ValueExpression getValue() {
    return value;
  }

  public void setValue(final javax.el.ValueExpression value) {
    this.value = value;
  }

  public javax.el.ValueExpression getMarkup() {
    return markup;
  }

  public void setMarkup(final javax.el.ValueExpression markup) {
    this.markup = markup;
  }

  public javax.el.MethodExpression getValueChangeListener() {
    return valueChangeListener;
  }

  public void setValueChangeListener(final javax.el.MethodExpression valueChangeListener) {
    this.valueChangeListener = valueChangeListener;
  }

  public javax.el.ValueExpression getOnchange() {
    return onchange;
  }

  public void setOnchange(final javax.el.ValueExpression onchange) {
    this.onchange = onchange;
  }

  public javax.el.ValueExpression getLabel() {
    return label;
  }

  public void setLabel(final javax.el.ValueExpression label) {
    this.label = label;
  }

  public javax.el.ValueExpression getRequiredMessage() {
    return requiredMessage;
  }

  public void setRequiredMessage(final javax.el.ValueExpression requiredMessage) {
    this.requiredMessage = requiredMessage;
  }



  @Override
  public void release() {
    super.release();
    validatorMessage = null;
    converter = null;
    validator = null;
    focus = null;
    tabIndex = null;
    required = null;
    readonly = null;
    disabled = null;
    tip = null;
    converterMessage = null;
    value = null;
    markup = null;
    valueChangeListener = null;
    onchange = null;
    label = null;
    requiredMessage = null;
  }
}